# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetConditionSizeResult',
    'AwaitableGetConditionSizeResult',
    'get_condition_size',
    'get_condition_size_output',
]

@pulumi.output_type
class GetConditionSizeResult:
    """
    A collection of values returned by getConditionSize.
    """
    def __init__(__self__, id=None, implementation=None, max=None, min=None, name=None, negate=None, required=None):
        if id and not isinstance(id, int):
            raise TypeError("Expected argument 'id' to be a int")
        pulumi.set(__self__, "id", id)
        if implementation and not isinstance(implementation, str):
            raise TypeError("Expected argument 'implementation' to be a str")
        pulumi.set(__self__, "implementation", implementation)
        if max and not isinstance(max, int):
            raise TypeError("Expected argument 'max' to be a int")
        pulumi.set(__self__, "max", max)
        if min and not isinstance(min, int):
            raise TypeError("Expected argument 'min' to be a int")
        pulumi.set(__self__, "min", min)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if negate and not isinstance(negate, bool):
            raise TypeError("Expected argument 'negate' to be a bool")
        pulumi.set(__self__, "negate", negate)
        if required and not isinstance(required, bool):
            raise TypeError("Expected argument 'required' to be a bool")
        pulumi.set(__self__, "required", required)

    @property
    @pulumi.getter
    def id(self) -> int:
        """
        Custom format condition size ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def implementation(self) -> str:
        """
        Implementation.
        """
        return pulumi.get(self, "implementation")

    @property
    @pulumi.getter
    def max(self) -> int:
        """
        Max size in GB.
        """
        return pulumi.get(self, "max")

    @property
    @pulumi.getter
    def min(self) -> int:
        """
        Min size in GB.
        """
        return pulumi.get(self, "min")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specification name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def negate(self) -> bool:
        """
        Negate flag.
        """
        return pulumi.get(self, "negate")

    @property
    @pulumi.getter
    def required(self) -> bool:
        """
        Computed flag.
        """
        return pulumi.get(self, "required")


class AwaitableGetConditionSizeResult(GetConditionSizeResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetConditionSizeResult(
            id=self.id,
            implementation=self.implementation,
            max=self.max,
            min=self.min,
            name=self.name,
            negate=self.negate,
            required=self.required)


def get_condition_size(max: Optional[int] = None,
                       min: Optional[int] = None,
                       name: Optional[str] = None,
                       negate: Optional[bool] = None,
                       required: Optional[bool] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetConditionSizeResult:
    """
    <!-- subcategory:Profiles -> Custom Format Condition Size data source.
    For more information refer to [Custom Format Conditions](https://wiki.servarr.com/lidarr/settings#conditions).

    {{% examples %}}
    ## Example Usage
    {{% example %}}

    ```python
    import pulumi
    import pulumi_lidarr as lidarr

    example_condition_size = lidarr.Profiles.get_condition_size(name="Example",
        negate=False,
        required=False,
        min=5,
        max=50)
    example_custom_format = lidarr.profiles.CustomFormat("exampleCustomFormat",
        include_custom_format_when_renaming=False,
        specifications=[example_condition_size])
    ```
    {{% /example %}}
    {{% /examples %}}


    :param int max: Max size in GB.
    :param int min: Min size in GB.
    :param str name: Specification name.
    :param bool negate: Negate flag.
    :param bool required: Computed flag.
    """
    __args__ = dict()
    __args__['max'] = max
    __args__['min'] = min
    __args__['name'] = name
    __args__['negate'] = negate
    __args__['required'] = required
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('lidarr:Profiles/getConditionSize:getConditionSize', __args__, opts=opts, typ=GetConditionSizeResult).value

    return AwaitableGetConditionSizeResult(
        id=pulumi.get(__ret__, 'id'),
        implementation=pulumi.get(__ret__, 'implementation'),
        max=pulumi.get(__ret__, 'max'),
        min=pulumi.get(__ret__, 'min'),
        name=pulumi.get(__ret__, 'name'),
        negate=pulumi.get(__ret__, 'negate'),
        required=pulumi.get(__ret__, 'required'))


@_utilities.lift_output_func(get_condition_size)
def get_condition_size_output(max: Optional[pulumi.Input[int]] = None,
                              min: Optional[pulumi.Input[int]] = None,
                              name: Optional[pulumi.Input[str]] = None,
                              negate: Optional[pulumi.Input[bool]] = None,
                              required: Optional[pulumi.Input[bool]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetConditionSizeResult]:
    """
    <!-- subcategory:Profiles -> Custom Format Condition Size data source.
    For more information refer to [Custom Format Conditions](https://wiki.servarr.com/lidarr/settings#conditions).

    {{% examples %}}
    ## Example Usage
    {{% example %}}

    ```python
    import pulumi
    import pulumi_lidarr as lidarr

    example_condition_size = lidarr.Profiles.get_condition_size(name="Example",
        negate=False,
        required=False,
        min=5,
        max=50)
    example_custom_format = lidarr.profiles.CustomFormat("exampleCustomFormat",
        include_custom_format_when_renaming=False,
        specifications=[example_condition_size])
    ```
    {{% /example %}}
    {{% /examples %}}


    :param int max: Max size in GB.
    :param int min: Min size in GB.
    :param str name: Specification name.
    :param bool negate: Negate flag.
    :param bool required: Computed flag.
    """
    ...
